Jupiter - Zadanie #1638

Zadanie # 1637 (Rozwigzany): Notyfikacje systemowe
Utworzenie serwisu do zapisywania notyfikacji
2017-04-18 09:40 - Michat Komar

Status: Rozwigzany Start date: 2017-05-11
Priority: Normalny Due date: 2017-05-11
Assignee: Michat Komar % Done: 100%

Category: backend Estimated time: 0.00 hour

Target version: 0.3

Developer: Michat Komar Tester: tukasz Waskiewicz
Description

Serwis powinien pozwala¢ na zapiwywanie oraz odczyt notyfikacji. Ponadto, podczas zapisywania notyfikacji, powinien zosta¢
wystany event, ktéry spowoduje wystanie wiadomosci poprzez websocket do wszystkich zainteresowanych.

Nalezy umozliwi¢ zdefiniowanie 2 typow adresatow: konkretny uzytkownik oraz rola.
W przypadku roli trzeba tez dookresli¢ grupe uzytkownikow oraz, czy informacja ma sie propagowac w gore (np. czy wysytac¢ do
administratora, gdy adresatem jest redaktor).

Dodatkowo nalezy zaimplementowac oznaczanie notyfikacji jako przeczytana + usuwanie per uzytkownik.

Serwis powinien integrowac sie z serwisem wiadomosci. Weryfikacja, czy adresat wiadomosci jest dobry, powinna sie odbywacé
poprzez filtry definiowane podczas rejestraciji odbiorcy wiadomosci (rejestracja ma miejsce podczas otwarcia websocketa).

Related issues:
Follows Jupiter - Zadanie # 1708: Rejestracja uzytkownikéw jako odbiorcéw wia... Zamkniety 2017-05-10 2017-05-10

Associated revisions

Revision c4bf7d0d - 2017-09-25 14:55 - Michat Komar

refs #1638: Dodanie serwisu w wersji #1

Revision 3f5dbdc4 - 2017-09-25 14:55 - Michat Komar

refs #1638: Dodanie modelu w jpa + sql

Revision 0517b5¢8 - 2017-09-25 14:55 - Michat Komar

refs #1638: Dodanie modelu w jpa + sql - kolejny etap

Revision 6381e390 - 2017-09-25 14:55 - Michat Komar

refs #1638: Dodanie wyszukiwania duplikatéw i doklejanie zrodet

Zmiana modelu -> jedna notyfikacja moze mie¢ wiele zrodet, w ten sposéb

nie duplikujemy notyfikacji

Revision 4245¢215 - 2017-09-25 14:55 - Michat Komar
refs #1638: Persystowanie notyfikacji. Obstuga wielu zrodet

Revision a0ae81ee - 2017-09-26 10:03 - Michat Komar

refs #1638: Dodanie dezaktualizacji confirmation required po confirmed

Revision 66¢c0e60f - 2017-09-26 12:35 - Michat Komar

refs #1638: Dodanie kontrolera

Revision 8938030f - 2017-09-26 12:48 - Michat Komar

refs #1638: Poprawienie konwersji

Revision f0c4c73e - 2017-09-26 12:48 - Michat Komar

refs #1638: Poprawienie konwersiji

Revision f4d04fc9 - 2017-09-27 07:59 - Michat Komar

refs #1638: Poprawienie sqli w h2

Revision 17a5889c - 2017-09-28 07:55 - Michat Komar

refs #1638: Dodanie animowanej ikonki z powiadomieniami

Revision 8cda1112 - 2017-09-29 10:35 - Michat Komar

refs #1638: Dodanie listy i szczegotéw notyfikaciji. j-autosize - moved

Revision 6d85f5d5 - 2017-09-29 12:07 - Michat Komar

refs #1638: Zmiana logiki weyfikaciji ilosci notyfikacji. Ttumaczenie

Revision 7386d095 - 2017-09-29 13:18 - Michat Komar

refs #1638: Tlumaczenia. Poprawki.

Revision 2632d6fb - 2017-10-02 15:20 - Michat Komar

refs #1638: Dodanie obstugi publishing notification
Revision 359a7de4 - 2017-10-04 13:16 - Michat Komar
refs #1638: Dodanie obstugi wszystkich rodzajow notyfikacji.
Ponadto poprawienie RWD dla filtréw w tabelach. Poprawienie btednej

obstugi Operation.

History

#1 - 2017-04-18 11:25 - Michat Komar
- Description updated

#2 - 2017-04-18 13:10 - Michat Komar
- Assignee set to Michat Komar

#3 - 2017-06-01 11:58 - Michat Komar

- Description updated

- Assignee changed from Michat Komar to Jarostaw Babel
- Developer Jarostaw Bgbel added

- Tester Michat Komar added

#4 - 2017-06-01 11:58 - Michat Komar
- Follows Zadanie #1708: Rejestracja uzytkownikéw jako odbiorcow wiadomosci added

#5 - 2017-08-08 11:38 - Michat Komar

- Assignee changed from Jarostaw Bgbel to Michat Komar
- Developer Michat Komar added

- Tester tukasz Waskiewicz added

#6 - 2017-08-09 08:10 - Michat Komar
- Assignee changed from Michat Komar to Wojtek Hury
- Developer Wojtek Hury added

#7 - 2017-08-31 13:08 - Wojtek Hury
- Assignee changed from Wojtek Hury to Michat Komar
- Developer Michat Komar added

#8 - 2017-10-04 13:27 - Michat Komar

- Status changed from Nowy to Rozwigzany

- Assignee changed from Michat Komar to tukasz Waskiewicz
- % Done changed from 0 to 100

W miedzyczasie zmienita sie koncepcja.

Notyfikacje przeznaczone sg tylko dla konkretnych uzytkownikéw (nie dla rél). Podczas dodawania notyfikacji trzeba okresli¢ kogo ona dotyczy. Za
okreslanie adresatow odpowiedzialna jest klasa DocumentNotificationsProducer - w ramach testow mozna zweryfikowaé, czy dziata poprawnie.

Nie dorabiatem testéw integracyjnych i jednostkowych do tego serwisu.

Flow przetwarzania wyglada nastepujaco:

1. Producer obstuguje event aplikacji i w tworzy na jego podstawie notyfikacje (moze powsta¢ wiele notyfikacji w wyniku jednego eventu). W ramach
eventu wszystkie wygenerowane notyfikacje maja jednego, takiego samego sourceUsera. Notyfikacja jest generowana per target user.

2. Wygenerowane notyfikacje przekazywane sg do notificationservice. Tam sprawdzane jest, czy notyfikacja nie jest duplikatem (taki sam targetUser,
zrédto notyfikacji - dokument, proces; typ notyfikacji oraz flagi read=false i valid = true). Jezeli nie jest duplikatem dodawana jest nowa notyfikacja,
jezeli jest, dodawany jest sourceuser do istniejacej notyfikacji. Notyfikacja nastepnie jest wysytana poprzez websocket do targetUsera. Notyfikacja jest
wysytana tylko w momencie, gdy zostata zmodyfikowana (jezeli sourceUser na duplikacie istnieje, wtedy nie ma zmiany)
3. Na koniec weryfikowane jest to czy obecna notyfikacja nie ma wptywu na istniejace. W tym momencie jezeli przychodzi notyfikacja CONFIRMED,
wszystkie notyfikacje CONFIRMATION_REQUIRED majg ustawiang flage valid na false.

#9 - 2017-10-13 14:48 - Michat Komar

- Status changed from Rozwigzany to Testowanie

#10 - 2017-10-18 09:52 - Lukasz Waskiewicz
- Status changed from Testowanie to Odpowiedz
- Assignee changed from tukasz Waskiewicz to Michat Komar

notyfikacja Potwierdzono nie przestaje by¢ aktualna jesli inny uzytkownik opublikuje zmiany

#11 - 2017-10-19 11:49 - Michat Komar

- Status changed from Odpowiedz to Rozwigzany

Przedyskutujemy kwestie zachowania notyfikacji na spotkaniu.
